/*================================================================================================================*/
// THESE ARE THE INFORMATIONS OF THE MAP:
/*================================================================================================================*/
// THE WINTER WAR CREATED BY DANY:
// NOVEMBRE 2006:
// FROM TEXAS BY ENSEMBLE:
// OCTOBER 2003:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************** CHOOSES WHICH NATIVES APPEAR ON THE MAP: ********************************** //
/*----------------------------------------------------------------------------------------------------------------*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
/*----------------------------------------------------------------------------------------------------------------*/
	    // ALL IROQUOIS ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
/*----------------------------------------------------------------------------------------------------------------*/		
   {
/*----------------------------------------------------------------------------------------------------------------*/   
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");

		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois");

		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");

		subCiv3=rmGetCivID("Iroquois");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Iroquois");
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ****************************************** PICKS THE MAP SIZE: *********************************************** //
/*================================================================================================================*/
	  // int playerTiles=10000;
	     int playerTiles=25000;
	
	  // if (cNumberNonGaiaPlayers >4)
	  //	playerTiles = 9500;

	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// *************************************** DEFINE THE MAP PARAMETERS: ******************************************* //
/*================================================================================================================*/	
	  // SET THE MAP ELEVATION PARAMETERS:
	  // rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	  rmSetMapElevationHeightBlend(1);
	
	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(4.0);
	  
	  // PICKS A LIGHTING:
	  //rmSetLightingSet("Texas");
	    rmSetLightingSet("Great Lakes Winter"); // FROM GREAT LAKES:

      // PICKS THE DEFAULT WATER:
	  //rmSetSeaType("Amazon River");
	    rmSetSeaType("great lakes"); // FROM GREAT LAKES:
	 
      // SET THE BASE TERRAIN MIX:
      //rmSetBaseTerrainMix("texas_grass");
	    rmSetBaseTerrainMix("greatlakes_snow"); // FROM GREAT LAKES:
	  
	  // DEFINE THE TERRAIN INITIALIZATION:
	  //rmTerrainInitialize("texas\ground1_tex", 5.0);
	    rmTerrainInitialize("great_lakes\ground_ice1_gl", 1.0);
	  
	  // SET THE MAP TYPE:
	  //rmSetMapType("texas");
	  //rmSetMapType("grass");
	  //rmSetMapType("land");
	    rmSetMapType("greatlakes");
		rmSetMapType("snow");
		rmSetMapType("water");
		
	  // SET GLOBAL SNOW:
	  rmSetGlobalSnow( 1.0 );

	  // CHOOSE MERCS:
	  chooseMercs();

	  // CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(true);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************ DEFINE SOME CLASSES. THESE ARE USED LATER FOR CONSTRAINTS: ************************** //
/*================================================================================================================*/      
	   int classPlayer=rmDefineClass("player");
       rmDefineClass("startingUnit");
       rmDefineClass("classForest");
	   rmDefineClass("classCliff");
	   rmDefineClass("nuggets");
	   rmDefineClass("natives");
/*================================================================================================================*/   
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
       // MAP EDGE CONSTRAINTS:
	   int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));
       int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  //DAL - was 24
	
       // CARDINAL DIRECTIONS FOR EACH 45 DEGREES:
	   int North1ward=rmCreatePieConstraint("north1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(45));
       int North2ward=rmCreatePieConstraint("north2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(46), rmDegreesToRadians(90));
       int East1ward=rmCreatePieConstraint("east1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(91), rmDegreesToRadians(136));
       int East2ward=rmCreatePieConstraint("east2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(137), rmDegreesToRadians(180));
       int South1ward=rmCreatePieConstraint("south1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(181), rmDegreesToRadians(226));
       int South2ward=rmCreatePieConstraint("south2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(226), rmDegreesToRadians(270));
       int West1ward=rmCreatePieConstraint("west1MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(271), rmDegreesToRadians(316));
       int West2ward=rmCreatePieConstraint("west2MapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(317), rmDegreesToRadians(360));
   
       // CARDINAL DIRECTIONS FOR NW NE SE SW :
	   //int NWward=rmCreatePieConstraint("NWMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(135));
       //int NEward=rmCreatePieConstraint("NEMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(44));
       //int SEward=rmCreatePieConstraint("SEMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(136), rmDegreesToRadians(225));
       //int SWward=rmCreatePieConstraint("SWMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(226), rmDegreesToRadians(44));
   
	   // CARDINAL DIRECTIONS FOR EACH 90 DEGREES:
       int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(0), rmDegreesToRadians(90));
       int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(180), rmDegreesToRadians(270));
       int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(90), rmDegreesToRadians(180));
       int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(270), rmDegreesToRadians(360));
  
	   // CREATE BOX CONSTRAINT:
	   int Westconstraint = rmCreateBoxConstraint("stay in East Box", 0, 1.0, 0.4, 0.6); 
	   int Eastconstraint = rmCreateBoxConstraint("stay in West Box", 1.0, 0.0, 0.6, 0.4); 
	   
	   // SHIPS VS. SHIPS:
       int shipVsShip=rmCreateTypeDistanceConstraint("ships avoid ship", "ship", 5.0);
	   
	   // RESOURCES AVOIDANCE:
	   int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
       int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
       int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
       int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
     
	   // DECORATION AVOIDANCE:
       int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
	  
	   // COW:
       int avoidCow=rmCreateTypeDistanceConstraint("avoid cow", "cow", 8.0);
       int cowAvoidCow=rmCreateTypeDistanceConstraint("cow avoid cow", "cow", 16.0);
	   
	   // MUSKOX:
       int avoidMuskOx=rmCreateTypeDistanceConstraint("avoid muskOx", "muskOx", 8.0);
       int muskOxAvoidMuskOx=rmCreateTypeDistanceConstraint("muskOx avoid muskOx", "muskOx", 16.0);
	  
	   // NUGGET:
	   int avoidNugget=rmCreateClassDistanceConstraint("stuff avoids nugget", rmClassID("nuggets"), 8.0);
       int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("nuggets"), 40.0);
	  
	   // DEER:
       int avoidDeer=rmCreateTypeDistanceConstraint("avoid deer", "deer", 8.0);
       int deerAvoidDeer=rmCreateTypeDistanceConstraint("deer avoid deer", "deer", 16.0); 
  
       // GOLD:
       int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "minegold", 8.0);
       int goldAvoidGold=rmCreateTypeDistanceConstraint("gold avoid gold", "minegold", 16.0);
	   
	   // CARIBOU:
	   int avoidCaribou=rmCreateTypeDistanceConstraint("avoid caribou", "caribou", 8.0);
       int caribouAvoidCaribou=rmCreateTypeDistanceConstraint("caribou avoid caribou", "caribou", 16.0);
	  
	   // BERRYBUSH:
       int avoidBerries=rmCreateTypeDistanceConstraint("avoid berrybush", "berrybush", 8.0);
       int berriesAvoidBerries=rmCreateTypeDistanceConstraint("berrybush avoid berrybush", "berrybush", 16.0);
	
	   // FRUITS (BERRYBUSH):
       int avoidFruits=rmCreateTypeDistanceConstraint("avoid fruits", "berrybush", 8.0);
       int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("fruits avoid fruits", "berrybush", 25.0);
	
       // MOOSE:
       int avoidMoose=rmCreateTypeDistanceConstraint("avoid the moose", "moose", 10.0); 	   
	   
	   // PLAYER CONSTRAINTS:
       int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 20.0);
       int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 12.0);
       //int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0);  
	   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 40.0);  
	   int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 20.0);
	   int smallMapPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 70.0);

	   // Nature avoidance
	   //int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
	   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 12.0);
	   int forestAvoidForest=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 18.0);
	   //int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
	
       // Unit avoidance
       int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
       int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
       int avoidStartingUnitsLarge=rmCreateClassDistanceConstraint("objects avoid starting units large", rmClassID("startingUnit"), 50.0);
  	   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 10.0);
	 
	   // AVOID IMPASSABLE LAND:
       int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 10.0);
       int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 8.0);
	   int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
 
	   // CIRCLE CONSTRAINT:
	   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************** DEFINE AND PLACE THE LOCATIONS OF THE PLAYERS: ******************************** //
/*================================================================================================================*/
   	    if ( cNumberTeams == 2 ) // IF THERE IS 2 TEAMS:
/*----------------------------------------------------------------------------------------------------------------*/	
	{
/*----------------------------------------------------------------------------------------------------------------*/	
		rmSetPlacementTeam(0); // LOCATION OF TEAM NUMBER 1:
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.15, 0.35);
/*----------------------------------------------------------------------------------------------------------------*/		
		if (cNumberNonGaiaPlayers >6) // IF THERE IS MORE THAN 6 PLAYERS:
		{
			rmSetPlacementSection(0.13, 0.37);
		}
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		   
		rmSetPlacementTeam(1); // LOCATION OF TEAM NUMBER 2:
/*----------------------------------------------------------------------------------------------------------------*/		
		rmSetPlacementSection(0.65, 0.85);
/*----------------------------------------------------------------------------------------------------------------*/		
		if (cNumberNonGaiaPlayers >6) // IF THERE IS MORE THAN 6 PLAYERS:
		{
			rmSetPlacementSection(0.63, 0.87);
		}
/*----------------------------------------------------------------------------------------------------------------*/		
		rmPlacePlayersCircular(0.35, 0.40, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/		   
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	else // IF THERE IS IS NOT 2 TEAMS:
/*----------------------------------------------------------------------------------------------------------------*/	
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ******************************* DEFINE AND PLACE THE SET UP PLAYER AREAS: ************************************ //
/*----------------------------------------------------------------------------------------------------------------*/
      float playerFraction=rmAreaTilesToFraction(100);
/*----------------------------------------------------------------------------------------------------------------*/
      for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/
   {
/*----------------------------------------------------------------------------------------------------------------*/
      // CREATE THE AREA:
      int id=rmCreateArea("Player"+i);
      
	  // ASSIGN TO THE PLAYER:
      rmSetPlayerArea(i, id);
      
	  // SET THE SIZE:
      rmSetAreaSize(id, playerFraction, playerFraction);
      
	  // ADD AREA TO CLASS:
	  rmAddAreaToClass(id, classPlayer);
      
	  // SET AREA MIN AND MAX BLOBS:
	  rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      
	  // ADD AREA CONSTRAINT:
	  rmAddAreaConstraint(id, playerConstraint); 
      //rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	  // SET AREA LOC PLAYER:
	  rmSetAreaLocPlayer(id, i);
	  
	  // SET AREA TERRAIN TYPE:
	  //rmSetAreaTerrainType(id, "texas\ground2");
	  //rmSetAreaTerrainType(id, "great_lakes\ground_grass1_gl");
	  rmSetAreaTerrainType(id, "great_lakes\ground_snow2_gl");
      
	  // SET AREA WARN FAILURE:
	  rmSetAreaWarnFailure(id, false);
/*----------------------------------------------------------------------------------------------------------------*/
   }
/*----------------------------------------------------------------------------------------------------------------*/
      // BUILD THE AREAS:
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE NATIVES TRIBES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
    	if (subCiv0 == rmGetCivID("iroquois"))
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int iroquoisVillage1ID = -1;
		iroquoisVillage1ID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage1ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage1ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage1ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage1ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage1ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage1ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage1ID, avoidCliffs);
		//rmAddGroupingConstraint(iroquoisVillage1ID, North1ward);
		//rmPlaceGroupingAtLoc(iroquoisVillage1ID, 0, 0.5, 0.5);
		  rmPlaceGroupingAtLoc(iroquoisVillage1ID, 0, 0.10, 0.60);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv1 == rmGetCivID("iroquois"))
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int iroquoisVillage2ID = -1;
		iroquoisVillage2ID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage2ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage2ID, rmXFractionToMeters(0.5));
		  rmSetGroupingMaxDistance(iroquoisVillage2ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage2ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage2ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage2ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage2ID, avoidCliffs);
		//rmAddGroupingConstraint(iroquoisVillage2ID, South1ward);
		//rmPlaceGroupingAtLoc(iroquoisVillage2ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(iroquoisVillage2ID, 0, 0.40, 0.89);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv2 == rmGetCivID("iroquois"))
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int iroquoisVillage3ID = -1;
		iroquoisVillage3ID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage3ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage3ID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquoisVillage3ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage3ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage3ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage3ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage3ID, East1ward);
		//rmPlaceGroupingAtLoc(iroquoisVillage3ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(iroquoisVillage3ID, 0, 0.60, 0.10);
	} 
/*----------------------------------------------------------------------------------------------------------------*/
		if (subCiv3 == rmGetCivID("iroquois"))
/*----------------------------------------------------------------------------------------------------------------*/		
	{  
		int iroquoisVillage4ID = -1;
		iroquoisVillage4ID = rmCreateGrouping("iroquois village 4", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquoisVillage4ID, 0.0);
		//rmSetGroupingMaxDistance(iroquoisVillage4ID, rmXFractionToMeters(0.5));
		rmSetGroupingMaxDistance(iroquoisVillage4ID, 0.0);
		rmAddGroupingConstraint(iroquoisVillage4ID, avoidImpassableLand);
		rmAddGroupingToClass(iroquoisVillage4ID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquoisVillage4ID, avoidNatives);
		//rmAddGroupingConstraint(iroquoisVillage4ID, West1ward);
		//rmPlaceGroupingAtLoc(iroquoisVillage4ID, 0, 0.5, 0.5);
		rmPlaceGroupingAtLoc(iroquoisVillage4ID, 0, 0.89, 0.43);
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************************* DEFINE THE TCID AND THE STARTING UNITS: ************************************** //
/*================================================================================================================*/
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    //rmAddObjectDefConstraint(startingUnits, avoidAll);

	    int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
/*----------------------------------------------------------------------------------------------------------------*/	
	    else
/*----------------------------------------------------------------------------------------------------------------*/		
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/
// ********************* GIVE IT A LITTLE WIGGLE ROOM FOR MAPS WITH GREATER THAN FOUR PLAYERS ******************* //
/*----------------------------------------------------------------------------------------------------------------*/
		if ( cNumberNonGaiaPlayers > 4 )
		{
			rmSetObjectDefMinDistance(startingTCID, 0.0);
			rmSetObjectDefMaxDistance(startingTCID, 6.0);
		}
/*----------------------------------------------------------------------------------------------------------------*/		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************************* PLACE THE TCID AND THE STARTING UNITS: ************************************* //
/*================================================================================================================*/
	for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	
	{
		// PLACE THE STARTING UNITS AND A TC:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		vector closestPoint=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingUnits, i));
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ************************************ LET'S TRY PONDS INSTEAD OF CLIFFS: ************************************** //
/*================================================================================================================*/
	  int pondClass=rmDefineClass("pond");
      //int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 60.0);
	  int pondConstraint=rmCreateClassDistanceConstraint("ponds avoid ponds", rmClassID("pond"), 10.0);
/*----------------------------------------------------------------------------------------------------------------*/
      int numPonds=cNumberNonGaiaPlayers;
/*----------------------------------------------------------------------------------------------------------------*/	  
	  for(i=0; <numPonds)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
/*----------------------------------------------------------------------------------------------------------------*/   
      //int smallPondID=rmCreateArea("small pond"+i);
	    int smallPondID=rmCreateArea("small pond");
      //rmSetAreaSize(smallPondID, rmAreaTilesToFraction(250), rmAreaTilesToFraction(400));
	    rmSetAreaSize(smallPondID, rmAreaTilesToFraction(3500), rmAreaTilesToFraction(3500));
      //rmSetAreaWaterType(smallPondID, "saguenay lake");
	    //rmSetAreaWaterType(smallPondID, "texas pond");
		  rmSetAreaWaterType(smallPondID, "great lakes ice");
      rmSetAreaBaseHeight(smallPondID, 4);
      rmAddAreaToClass(smallPondID, pondClass);
      rmSetAreaCoherence(smallPondID, 0.4);
      rmSetAreaSmoothDistance(smallPondID, 5);
      rmAddAreaConstraint(smallPondID, pondConstraint);
      //rmAddAreaConstraint(smallPondID, avoidTradeRoute);
      //rmAddAreaConstraint(smallPondID, avoidImportantItem);
      //rmAddAreaConstraint(smallPondID, avoidImpassableLand);
      // rmAddAreaConstraint(smallPondID, avoidCliffs);
	  //rmAddAreaConstraint(smallPondID, avoidSocket);
	  //rmAddAreaConstraint(smallPondID, avoidStartingUnitsBay);
	  //rmAddAreaConstraint(smallPondID, Southward);
      rmSetAreaWarnFailure(smallPondID, false);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  rmSetAreaLocation(smallPondID, 0.5, 0.5); 
      rmBuildArea(smallPondID);
/*----------------------------------------------------------------------------------------------------------------*/	  
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ******************************** VARIABLES NEEDED BY CLIFFS AND FORESTS: ************************************* //
/*================================================================================================================*/
	  // TEXT:
	  int numTries = -1;
	  int failCount = -1;   
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS 1: **************************************** //
/*================================================================================================================*/
	    //numTries=cNumberNonGaiaPlayers*2;
		  numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numTries)
	{
		//int cliffEastID=rmCreateArea("cliff east"+i);
		  int cliffEastID=rmCreateArea("cliff east");
	    //rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));  // DAL - larger cliffs?
		  rmSetAreaSize(cliffEastID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));  // DAL - larger cliffs?
		
		rmSetAreaLocation(cliffEastID, 0.52, 0.85);
		
		rmSetAreaWarnFailure(cliffEastID, false);
		//rmSetAreaCliffType(cliffEastID, "Texas Grass");
		  rmSetAreaCliffType(cliffEastID, "rocky mountain edge");
		rmAddAreaToClass(cliffEastID, rmClassID("classCliff"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(cliffEastID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEastID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEastID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEastID, 1);
		//rmAddAreaTerrainLayer(cliffEastID, "texas\ground2_tex", 0, 2);
		rmAddAreaTerrainLayer(cliffEastID, "yukon\ground4_yuk", 0, 3);
        //rmAddAreaTerrainLayer(southIslandID, "yukon\ground5_yuk", 3, 6);
        //rmAddAreaTerrainLayer(southIslandID, "yukon\ground6_yuk", 6, 8);

		rmSetAreaObeyWorldCircleConstraint(cliffEastID, false);
		rmAddAreaConstraint(cliffEastID, cliffsAvoidCliffs);				// Avoid cliffs, please!
		//rmAddAreaConstraint(cliffEastID, cliffsConstraint); testing...
		//rmAddAreaConstraint(cliffEastID, playerConstraint);		// Keep cliffs away from the player.
		//rmAddAreaConstraint(cliffEastID, avoidImportantItem);
		//rmAddAreaConstraint(cliffEastID, avoidTradeRouteCliff);
		//rmAddAreaConstraint(cliffEastID, avoidCoin);
		rmAddAreaConstraint(cliffEastID, avoidNatives);
		//rmAddAreaConstraint(cliffEastID, pondConstraint);
		//rmAddAreaConstraint(cliffEastID, Northward);					// Go East, Mr. Cliff.
		//rmSetAreaMinBlobs(cliffEastID, 2);
		//rmSetAreaMaxBlobs(cliffEastID, 4);
		//rmSetAreaMinBlobDistance(cliffEastID, 10.0);
		//rmSetAreaMaxBlobDistance(cliffEastID, 20.0);
		//rmSetAreaMinBlobs(cliffEastID, 1);
		//rmSetAreaMaxBlobs(cliffEastID, 1);
		//rmSetAreaMinBlobDistance(cliffEastID, 0.0);
		//rmSetAreaMaxBlobDistance(cliffEastID, 0.0);
		rmSetAreaCoherence(cliffEastID, 0.2);
		rmSetAreaSmoothDistance(cliffEastID, 30);						// DAL - used to be 10
		rmSetAreaCoherence(cliffEastID, 0.25);
/*----------------------------------------------------------------------------------------------------------------*/
		if(rmBuildArea(cliffEastID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/			
	}
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS 2: **************************************** //
/*================================================================================================================*/
	    //numTries=cNumberNonGaiaPlayers*2;
		  numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numTries)
	{
		//int cliffWestID=rmCreateArea("cliff west"+i);
		  int cliffWestID=rmCreateArea("cliff west");
	    //rmSetAreaSize(cliffWestID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));  // DAL - larger cliffs?
		  rmSetAreaSize(cliffWestID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));  // DAL - larger cliffs?
		
		rmSetAreaLocation(cliffWestID, 0.85, 0.50);
		
		rmSetAreaWarnFailure(cliffWestID, false);
		//rmSetAreaCliffType(cliffWestID, "Texas Grass");
		  rmSetAreaCliffType(cliffWestID, "rocky mountain edge");
		rmAddAreaToClass(cliffWestID, rmClassID("classCliff"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(cliffWestID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWestID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWestID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWestID, 1);
		//rmAddAreaTerrainLayer(cliffWestID, "texas\ground2_tex", 0, 2);
		  rmAddAreaTerrainLayer(cliffWestID, "yukon\ground4_yuk", 0, 3);

		rmSetAreaObeyWorldCircleConstraint(cliffWestID, false);
		rmAddAreaConstraint(cliffWestID, cliffsAvoidCliffs);				// Avoid cliffs, please!
		//rmAddAreaConstraint(cliffWestID, playerConstraint);		// Keep cliffs away from the player.
		//rmAddAreaConstraint(cliffWestID, avoidImportantItem);
		//rmAddAreaConstraint(cliffWestID, avoidTradeRouteCliff);
		//rmAddAreaConstraint(cliffWestID, avoidCoin);
		rmAddAreaConstraint(cliffWestID, avoidNatives);
		//rmAddAreaConstraint(cliffWestID, pondConstraint);
		//rmAddAreaConstraint(cliffWestID, Northward);					// Go East, Mr. Cliff.
		//rmSetAreaMinBlobs(cliffWestID, 2);
		//rmSetAreaMaxBlobs(cliffWestID, 4);
		//rmSetAreaMinBlobDistance(cliffWestID, 10.0);
		//rmSetAreaMaxBlobDistance(cliffWestID, 20.0);
		rmSetAreaMinBlobs(cliffWestID, 1);
		rmSetAreaMaxBlobs(cliffWestID, 1);
		rmSetAreaMinBlobDistance(cliffWestID, 0.0);
		rmSetAreaMaxBlobDistance(cliffWestID, 0.0);
		rmSetAreaCoherence(cliffWestID, 0.2);
		rmSetAreaSmoothDistance(cliffWestID, 30);						// DAL - used to be 10
		rmSetAreaCoherence(cliffWestID, 0.25);
/*----------------------------------------------------------------------------------------------------------------*/
		if(rmBuildArea(cliffWestID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/			
	}
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS 3: **************************************** //
/*================================================================================================================*/
	    //numTries=cNumberNonGaiaPlayers*2;
		  numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numTries)
	{
		int cliffEast2ID=rmCreateArea("cliff east 2"+i);
	    //rmSetAreaSize(cliffEast2ID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));  // DAL - larger cliffs?
		  rmSetAreaSize(cliffEast2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));  // DAL - larger cliffs?
		
		rmSetAreaLocation(cliffEast2ID, 0.19, 0.48);
		
		rmSetAreaWarnFailure(cliffEast2ID, false);
		//rmSetAreaCliffType(cliffEast2ID, "Texas Grass");
		  rmSetAreaCliffType(cliffEast2ID, "rocky mountain edge");
		rmAddAreaToClass(cliffEast2ID, rmClassID("classCliff"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(cliffEast2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffEast2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffEast2ID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffEast2ID, 1);
		//rmAddAreaTerrainLayer(cliffEast2ID, "texas\ground2_tex", 0, 2);
		  rmAddAreaTerrainLayer(cliffEast2ID, "yukon\ground4_yuk", 0, 3);

		rmSetAreaObeyWorldCircleConstraint(cliffEast2ID, false);
		rmAddAreaConstraint(cliffEast2ID, cliffsAvoidCliffs);				// Avoid cliffs, please!
		//rmAddAreaConstraint(cliffEast2ID, playerConstraint);		// Keep cliffs away from the player.
		//rmAddAreaConstraint(cliffEast2ID, avoidImportantItem);
		//rmAddAreaConstraint(cliffEast2ID, avoidTradeRouteCliff);
		//rmAddAreaConstraint(cliffEast2ID, avoidCoin);
		rmAddAreaConstraint(cliffEast2ID, avoidNatives);
		//rmAddAreaConstraint(cliffEast2ID, pondConstraint);
		//rmAddAreaConstraint(cliffEast2ID, Northward);					// Go East, Mr. Cliff.
		//rmSetAreaMinBlobs(cliffEast2ID, 2);
		//rmSetAreaMaxBlobs(cliffEast2ID, 4);
		//rmSetAreaMinBlobDistance(cliffEast2ID, 10.0);
		//rmSetAreaMaxBlobDistance(cliffEast2ID, 20.0);
		rmSetAreaMinBlobs(cliffEast2ID, 1);
		rmSetAreaMaxBlobs(cliffEast2ID, 1);
		rmSetAreaMinBlobDistance(cliffEast2ID, 0.0);
		rmSetAreaMaxBlobDistance(cliffEast2ID, 0.0);
		rmSetAreaCoherence(cliffEast2ID, 0.2);
		rmSetAreaSmoothDistance(cliffEast2ID, 30);						// DAL - used to be 10
		rmSetAreaCoherence(cliffEast2ID, 0.25);
/*----------------------------------------------------------------------------------------------------------------*/
		if(rmBuildArea(cliffEast2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/			
	}
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE CLIFFS 4: **************************************** //
/*================================================================================================================*/
	    //numTries=cNumberNonGaiaPlayers*2;
		  numTries=cNumberNonGaiaPlayers*0.5;
	    failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/		
	    for(i=0; <numTries)
	{
		//int cliffWest2ID=rmCreateArea("cliff west 2"+i);
		  int cliffWest2ID=rmCreateArea("cliff west 2");
	    //rmSetAreaSize(cliffWest2ID, rmAreaTilesToFraction(350), rmAreaTilesToFraction(400));  // DAL - larger cliffs?
		  rmSetAreaSize(cliffWest2ID, rmAreaTilesToFraction(600), rmAreaTilesToFraction(600));  // DAL - larger cliffs?
		
		rmSetAreaLocation(cliffWest2ID, 0.48, 0.19);
		
		rmSetAreaWarnFailure(cliffWest2ID, false);
		//rmSetAreaCliffType(cliffWest2ID, "Texas Grass");
		  rmSetAreaCliffType(cliffWest2ID, "rocky mountain edge");
		rmAddAreaToClass(cliffWest2ID, rmClassID("classCliff"));	// Attempt to keep cliffs away from each other.
		rmSetAreaCliffEdge(cliffWest2ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffPainting(cliffWest2ID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffWest2ID, 7, 1.0, 1.0);
		rmSetAreaHeightBlend(cliffWest2ID, 1);
		//rmAddAreaTerrainLayer(cliffWest2ID, "texas\ground2_tex", 0, 2);
		  rmAddAreaTerrainLayer(cliffWest2ID, "yukon\ground4_yuk", 0, 3);

		rmSetAreaObeyWorldCircleConstraint(cliffWest2ID, false);
		rmAddAreaConstraint(cliffWest2ID, cliffsAvoidCliffs);				// Avoid cliffs, please!
		//rmAddAreaConstraint(cliffWest2ID, playerConstraint);		// Keep cliffs away from the player.
		//rmAddAreaConstraint(cliffWest2ID, avoidImportantItem);
		//rmAddAreaConstraint(cliffWest2ID, avoidTradeRouteCliff);
		//rmAddAreaConstraint(cliffWest2ID, avoidCoin);
		rmAddAreaConstraint(cliffWest2ID, avoidNatives);
		//rmAddAreaConstraint(cliffWest2ID, pondConstraint);
		//rmAddAreaConstraint(cliffWest2ID, Northward);					// Go East, Mr. Cliff.
		//rmSetAreaMinBlobs(cliffWest2ID, 2);
		//rmSetAreaMaxBlobs(cliffWest2ID, 4);
		//rmSetAreaMinBlobDistance(cliffWest2ID, 10.0);
		//rmSetAreaMaxBlobDistance(cliffWest2ID, 20.0);
		rmSetAreaMinBlobs(cliffWest2ID, 1);
		rmSetAreaMaxBlobs(cliffWest2ID, 1);
		rmSetAreaMinBlobDistance(cliffWest2ID, 0.0);
		rmSetAreaMaxBlobDistance(cliffWest2ID, 0.0);
		rmSetAreaCoherence(cliffWest2ID, 0.2);
		rmSetAreaSmoothDistance(cliffWest2ID, 30);						// DAL - used to be 10
		rmSetAreaCoherence(cliffWest2ID, 0.25);
/*----------------------------------------------------------------------------------------------------------------*/
		if(rmBuildArea(cliffWest2ID)==false)
		{
			// Stop trying once we fail 3 times in a row
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/			
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 1: **************************************** //
/*================================================================================================================*/
         int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest=rmCreateArea("forest "+i);
		   int forest=rmCreateArea("forest"+i);
         rmSetAreaWarnFailure(forest, false);
         rmSetAreaSize(forest, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest, "texas forest");
		   rmSetAreaForestType(forest, "great lakes forest snow");
		 // rmSetAreaForestType(forest, "dunes");
         rmSetAreaForestDensity(forest, 0.9);
         rmSetAreaForestClumpiness(forest, 0.8);
         rmSetAreaForestUnderbrush(forest, 0.0);
         //rmSetAreaMinBlobs(forest, 1);
         //rmSetAreaMaxBlobs(forest, 5);
         //rmSetAreaMinBlobDistance(forest, 10.0);
         //rmSetAreaMaxBlobDistance(forest, 30.0);
         rmSetAreaCoherence(forest, 0.4);
         rmSetAreaSmoothDistance(forest, 10);
         rmAddAreaToClass(forest, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest, avoidAll);
		 //rmAddAreaConstraint(forest, avoidNugget);
		 //rmAddAreaConstraint(forest, avoidDeer);
		 rmAddAreaConstraint(forest, forestAvoidForest);
		 rmAddAreaConstraint(forest, avoidNatives);
		 rmAddAreaConstraint(forest, playerConstraintForest);
		 //rmAddAreaConstraint(forest, avoidGold);
		 //rmAddAreaConstraint(forest, avoidCow);
		 rmAddAreaConstraint(forest, avoidMoose);
		 rmAddAreaConstraint(forest, edgeConstraint);
         rmAddAreaConstraint(forest, avoidCliffs); 
         rmAddAreaConstraint(forest, avoidImpassableLand); 
         //rmAddAreaConstraint(forest, avoidBerries); 
		 rmAddAreaConstraint(forest, Northward); 
		 rmAddAreaConstraint(forest, avoidStartingUnits); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 2: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest2=rmCreateArea("forest 2"+i);
		   int forest2=rmCreateArea("forest 2"+i);
         rmSetAreaWarnFailure(forest2, false);
         //rmSetAreaSize(forest2, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest2, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest2, "texas forest");
		   rmSetAreaForestType(forest2, "great lakes forest snow");
		 // rmSetAreaForestType(forest2, "dunes");
         rmSetAreaForestDensity(forest2, 0.9);
         rmSetAreaForestClumpiness(forest2, 0.8);
         rmSetAreaForestUnderbrush(forest2, 0.0);
         //rmSetAreaMinBlobs(forest2, 1);
         //rmSetAreaMaxBlobs(forest2, 5);
         //rmSetAreaMinBlobDistance(forest2, 10.0);
         //rmSetAreaMaxBlobDistance(forest2, 30.0);
         rmSetAreaCoherence(forest2, 0.4);
         rmSetAreaSmoothDistance(forest2, 10);
         rmAddAreaToClass(forest2, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest2, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest2, avoidAll);
		 //rmAddAreaConstraint(forest2, avoidNugget);
		 //rmAddAreaConstraint(forest2, avoidDeer);
		 rmAddAreaConstraint(forest2, forestAvoidForest);
		 rmAddAreaConstraint(forest2, avoidNatives);
		 rmAddAreaConstraint(forest2, playerConstraintForest);
		 //rmAddAreaConstraint(forest2, avoidGold);
		 //rmAddAreaConstraint(forest2, avoidCow);
		 rmAddAreaConstraint(forest2, avoidMoose);
		 rmAddAreaConstraint(forest2, edgeConstraint);
         rmAddAreaConstraint(forest2, avoidCliffs); 
         rmAddAreaConstraint(forest2, avoidImpassableLand); 
         //rmAddAreaConstraint(forest2, avoidBerries); 
		 rmAddAreaConstraint(forest2, Southward); 
		 rmAddAreaConstraint(forest2, avoidStartingUnits); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest2)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FORESTS 3: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest3=rmCreateArea("forest 3"+i);
		   int forest3=rmCreateArea("forest 3"+i);
         rmSetAreaWarnFailure(forest3, false);
         //rmSetAreaSize(forest3, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest3, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest3, "texas forest");
		   rmSetAreaForestType(forest3, "great lakes forest snow");
		 // rmSetAreaForestType(forest3, "dunes");
         rmSetAreaForestDensity(forest3, 0.9);
         rmSetAreaForestClumpiness(forest3, 0.8);
         rmSetAreaForestUnderbrush(forest3, 0.0);
         //rmSetAreaMinBlobs(forest3, 1);
         //rmSetAreaMaxBlobs(forest3, 5);
         //rmSetAreaMinBlobDistance(forest3, 10.0);
         //rmSetAreaMaxBlobDistance(forest3, 30.0);
         rmSetAreaCoherence(forest3, 0.4);
         rmSetAreaSmoothDistance(forest3, 10);
         rmAddAreaToClass(forest3, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest3, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest3, avoidAll);
		 //rmAddAreaConstraint(forest3, avoidNugget);
		 //rmAddAreaConstraint(forest3, avoidDeer);
		 rmAddAreaConstraint(forest3, forestAvoidForest);
		 rmAddAreaConstraint(forest3, avoidNatives);
		 rmAddAreaConstraint(forest3, playerConstraintForest);
		 //rmAddAreaConstraint(forest3, avoidGold);
		 //rmAddAreaConstraint(forest3, avoidCow);
		 rmAddAreaConstraint(forest3, avoidMoose);
		 rmAddAreaConstraint(forest3, edgeConstraint);
         rmAddAreaConstraint(forest3, avoidCliffs); 
         rmAddAreaConstraint(forest3, avoidImpassableLand); 
         //rmAddAreaConstraint(forest3, avoidBerries); 
		 rmAddAreaConstraint(forest3, Eastward); 
		 rmAddAreaConstraint(forest3, avoidStartingUnits); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest3)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/  
// ************************************* DEFINE AND PLACE THE FORESTS 4: **************************************** //
/*================================================================================================================*/
         //int forestTreeID = 0;
         //numTries=5*cNumberNonGaiaPlayers;
		   numTries=12;
         failCount=0;
/*----------------------------------------------------------------------------------------------------------------*/   
         for (i=0; <numTries)
/*----------------------------------------------------------------------------------------------------------------*/   
      { 
/*----------------------------------------------------------------------------------------------------------------*/	  
         //int forest4=rmCreateArea("forest 4"+i);
		   int forest4=rmCreateArea("forest 4"+i);
         rmSetAreaWarnFailure(forest4, false);
         //rmSetAreaSize(forest4, rmAreaTilesToFraction(75), rmAreaTilesToFraction(125));
		   rmSetAreaSize(forest4, rmAreaTilesToFraction(100), rmAreaTilesToFraction(100));
         //rmSetAreaForestType(forest4, "texas forest");
		   rmSetAreaForestType(forest4, "great lakes forest snow");
		 // rmSetAreaForestType(forest4, "dunes");
         rmSetAreaForestDensity(forest4, 0.9);
         rmSetAreaForestClumpiness(forest4, 0.8);
         rmSetAreaForestUnderbrush(forest4, 0.0);
         //rmSetAreaMinBlobs(forest4, 1);
         //rmSetAreaMaxBlobs(forest4, 5);
         //rmSetAreaMinBlobDistance(forest4, 10.0);
         //rmSetAreaMaxBlobDistance(forest4, 30.0);
         rmSetAreaCoherence(forest4, 0.4);
         rmSetAreaSmoothDistance(forest4, 10);
         rmAddAreaToClass(forest4, rmClassID("classForest")); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 rmAddAreaConstraint(forest4, forestConstraint);
/*----------------------------------------------------------------------------------------------------------------*/		 
         rmAddAreaConstraint(forest4, avoidAll);
		 //rmAddAreaConstraint(forest4, avoidNugget);
		 //rmAddAreaConstraint(forest4, avoidDeer);
		 rmAddAreaConstraint(forest4, forestAvoidForest);
		 rmAddAreaConstraint(forest4, avoidNatives);
		 rmAddAreaConstraint(forest4, playerConstraintForest);
		 //rmAddAreaConstraint(forest4, avoidGold);
		 rmAddAreaConstraint(forest4, avoidMoose);
		 rmAddAreaConstraint(forest4, edgeConstraint);
         rmAddAreaConstraint(forest4, avoidCliffs); 
         rmAddAreaConstraint(forest4, avoidImpassableLand); 
         //rmAddAreaConstraint(forest4, avoidBerries); 
		 rmAddAreaConstraint(forest4, Westward); 
		 rmAddAreaConstraint(forest4, avoidStartingUnits); 
/*----------------------------------------------------------------------------------------------------------------*/         
		 if(rmBuildArea(forest4)==false)
         {
            // Stop trying once we fail 3 times in a row.
            failCount++;
            if(failCount==5)
               break;
         }
         else
            failCount=0; 
/*----------------------------------------------------------------------------------------------------------------*/			
      } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE MUSKOX 1: ******************************************* //
/*================================================================================================================*/
      int muskOxID=rmCreateObjectDef("muskOx herd 1");
	  //rmAddObjectDefItem(muskOxID, "muskOx", 1, 0.0);
      rmAddObjectDefItem(muskOxID, "muskOx", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(muskOxID, 20.0);
      rmSetObjectDefMaxDistance(muskOxID, 30.0);
      rmAddObjectDefConstraint(muskOxID, avoidGold);
	  rmAddObjectDefConstraint(muskOxID, avoidMoose);
      rmAddObjectDefConstraint(muskOxID, forestConstraint);
      rmAddObjectDefConstraint(muskOxID, avoidMuskOx);
      rmAddObjectDefConstraint(muskOxID, avoidNugget);
      rmAddObjectDefConstraint(muskOxID, avoidCaribou);
      rmAddObjectDefConstraint(muskOxID, avoidNatives);
      //rmAddObjectDefConstraint(muskOxID, avoidBerries);
	  rmAddObjectDefConstraint(muskOxID, avoidFruits);
      rmAddObjectDefConstraint(muskOxID, muskOxAvoidMuskOx);
      rmAddObjectDefConstraint(muskOxID, edgeConstraint);
      rmAddObjectDefConstraint(muskOxID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(muskOxID, true);
      rmPlaceObjectDefPerPlayer(muskOxID, false);
	  //rmPlaceObjectDefPerPlayer(muskOxID, false, 2);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE MUSKOX 2: ******************************************* //
/*================================================================================================================*/
      int muskOx2ID=rmCreateObjectDef("muskOx herd 2");
	  //rmAddObjectDefItem(muskOx2ID, "muskOx", 1, 0.0);
      rmAddObjectDefItem(muskOx2ID, "muskOx", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(muskOx2ID, 40.0);
      rmSetObjectDefMaxDistance(muskOx2ID, 60.0);
      rmAddObjectDefConstraint(muskOx2ID, avoidGold);
	  rmAddObjectDefConstraint(muskOx2ID, avoidMoose);
      rmAddObjectDefConstraint(muskOx2ID, forestConstraint);
      rmAddObjectDefConstraint(muskOx2ID, avoidMuskOx);
      rmAddObjectDefConstraint(muskOx2ID, avoidNugget);
      rmAddObjectDefConstraint(muskOx2ID, avoidCaribou);
      rmAddObjectDefConstraint(muskOx2ID, avoidNatives);
      //rmAddObjectDefConstraint(muskOx2ID, avoidBerries);
	  rmAddObjectDefConstraint(muskOx2ID, avoidFruits);
      rmAddObjectDefConstraint(muskOx2ID, muskOxAvoidMuskOx);
      rmAddObjectDefConstraint(muskOx2ID, edgeConstraint);
      rmAddObjectDefConstraint(muskOx2ID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(muskOx2ID, true);
      rmPlaceObjectDefPerPlayer(muskOx2ID, false);
	  //rmPlaceObjectDefPerPlayer(muskOx2ID, false, 2);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE MUSKOX 3: ******************************************* //
/*================================================================================================================*/
      int muskOx3ID=rmCreateObjectDef("muskOx herd 3");
	  //rmAddObjectDefItem(muskOx3ID, "muskOx", 1, 0.0);
      rmAddObjectDefItem(muskOx3ID, "muskOx", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(muskOx3ID, 0.0);
      rmSetObjectDefMaxDistance(muskOx3ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(muskOx3ID, avoidGold);
	  rmAddObjectDefConstraint(muskOx3ID, avoidMoose);
      rmAddObjectDefConstraint(muskOx3ID, forestConstraint);
      rmAddObjectDefConstraint(muskOx3ID, avoidMuskOx);
      rmAddObjectDefConstraint(muskOx3ID, avoidNugget);
      rmAddObjectDefConstraint(muskOx3ID, avoidCaribou);
      rmAddObjectDefConstraint(muskOx3ID, avoidNatives);
      //rmAddObjectDefConstraint(muskOx3ID, avoidBerries);
	  rmAddObjectDefConstraint(muskOx3ID, avoidFruits);
      rmAddObjectDefConstraint(muskOx3ID, muskOxAvoidMuskOx);
      rmAddObjectDefConstraint(muskOx3ID, edgeConstraint);
      rmAddObjectDefConstraint(muskOx3ID, avoidImpassableLand);
      rmAddObjectDefConstraint(muskOx3ID, Westconstraint);
      rmSetObjectDefCreateHerd(muskOx3ID, true);
      rmPlaceObjectDefAtLoc(muskOx3ID, 0, 0.0, 1.0, 1);  
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE MUSKOX 4: ******************************************* //
/*================================================================================================================*/
      int muskOx4ID=rmCreateObjectDef("muskOx herd 4");
	  //rmAddObjectDefItem(muskOx4ID, "muskOx", 1, 0.0);
      rmAddObjectDefItem(muskOx4ID, "muskOx", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(muskOx4ID, 0.0);
      rmSetObjectDefMaxDistance(muskOx4ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(muskOx4ID, avoidGold);
	  rmAddObjectDefConstraint(muskOx4ID, avoidMoose);
      rmAddObjectDefConstraint(muskOx4ID, forestConstraint);
      rmAddObjectDefConstraint(muskOx4ID, avoidMuskOx);
      rmAddObjectDefConstraint(muskOx4ID, avoidNugget);
      rmAddObjectDefConstraint(muskOx4ID, avoidCaribou);
      rmAddObjectDefConstraint(muskOxID, avoidNatives);
      //rmAddObjectDefConstraint(muskOxID, avoidBerries);
	  rmAddObjectDefConstraint(muskOxID, avoidFruits);
      rmAddObjectDefConstraint(muskOx4ID, muskOxAvoidMuskOx);
      rmAddObjectDefConstraint(muskOx4ID, edgeConstraint);
      rmAddObjectDefConstraint(muskOx4ID, avoidImpassableLand);
      rmAddObjectDefConstraint(muskOx4ID, Eastconstraint);
      rmSetObjectDefCreateHerd(muskOx4ID, true);
      rmPlaceObjectDefAtLoc(muskOx4ID, 0, 1.0, 0.0, 1);    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE NUGGET 1: ******************************************* //
/*================================================================================================================*/
      int nuggetID=rmCreateObjectDef("Nugget Treasures 1");
    //rmAddObjectDefItem(nuggetID, "nugget", 1, 0.0);
      rmAddObjectDefItem(nuggetID, "nugget", 1, 6.0);
	  rmSetNuggetDifficulty(1, 3);
      rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
/*----------------------------------------------------------------------------------------------------------------*/	 
      rmAddObjectDefConstraint(nuggetID, avoidGold);
	  rmAddObjectDefConstraint(nuggetID, avoidMoose);
	  rmAddObjectDefConstraint(nuggetID, forestConstraint);
      rmAddObjectDefConstraint(nuggetID, avoidMuskOx);
      rmAddObjectDefConstraint(nuggetID, avoidNugget);
      rmAddObjectDefConstraint(nuggetID, avoidNatives);
      rmAddObjectDefConstraint(nuggetID, avoidCaribou);
      //rmAddObjectDefConstraint(nuggetID, avoidBerries);
	  rmAddObjectDefConstraint(nuggetID, avoidFruits);
      rmAddObjectDefConstraint(nuggetID, nuggetAvoidNugget);
      rmAddObjectDefConstraint(nuggetID, edgeConstraint);
      rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
/*----------------------------------------------------------------------------------------------------------------*/   
      rmSetObjectDefMinDistance(nuggetID, 20.0);
      rmSetObjectDefMaxDistance(nuggetID, 30.0);
      rmPlaceObjectDefPerPlayer(nuggetID, false);
    //rmPlaceObjectDefPerPlayer(nuggetID, false, 2);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE NUGGET 2: ******************************************* //
/*================================================================================================================*/
      int nugget2ID=rmCreateObjectDef("Nugget Treasures 2");
    //rmAddObjectDefItem(nugget2ID, "nugget", 1, 0.0);
      rmAddObjectDefItem(nugget2ID, "nugget", 1, 6.0);
	  rmSetNuggetDifficulty(1, 3);
      rmAddObjectDefToClass(nugget2ID, rmClassID("nuggets"));
/*----------------------------------------------------------------------------------------------------------------*/	 
      rmAddObjectDefConstraint(nugget2ID, avoidGold);
	  rmAddObjectDefConstraint(nugget2ID, avoidMoose);
	  rmAddObjectDefConstraint(nugget2ID, forestConstraint);
      rmAddObjectDefConstraint(nugget2ID, avoidMuskOx);
      rmAddObjectDefConstraint(nugget2ID, avoidNugget);
      rmAddObjectDefConstraint(nugget2ID, avoidNatives);
      rmAddObjectDefConstraint(nugget2ID, avoidCaribou);
      //rmAddObjectDefConstraint(nugget2ID, avoidBerries);
	  rmAddObjectDefConstraint(nugget2ID, avoidFruits);
      rmAddObjectDefConstraint(nugget2ID, nuggetAvoidNugget);
      rmAddObjectDefConstraint(nugget2ID, edgeConstraint);
      rmAddObjectDefConstraint(nugget2ID, avoidImpassableLand);
/*----------------------------------------------------------------------------------------------------------------*/   
      rmSetObjectDefMinDistance(nugget2ID, 40.0);
      rmSetObjectDefMaxDistance(nugget2ID, 60.0);
      rmPlaceObjectDefPerPlayer(nugget2ID, false);
    //rmPlaceObjectDefPerPlayer(nugget2ID, false, 2);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE NUGGET 3: ***************************************** //
/*================================================================================================================*/
      int nugget3ID=rmCreateObjectDef("Nugget Treasures 3");
    //rmAddObjectDefItem(nugget3ID, "nugget", 1, 0.0);
      rmAddObjectDefItem(nugget3ID, "nugget", 1, 6.0);
	  rmSetNuggetDifficulty(1, 3);
      rmAddObjectDefToClass(nugget3ID, rmClassID("nuggets"));
/*----------------------------------------------------------------------------------------------------------------*/	      
      rmAddObjectDefConstraint(nugget3ID, avoidGold);
	  rmAddObjectDefConstraint(nugget3ID, avoidMoose);
	  rmAddObjectDefConstraint(nugget3ID, forestConstraint);
      rmAddObjectDefConstraint(nugget3ID, avoidMuskOx);
      rmAddObjectDefConstraint(nugget3ID, avoidNugget);
      rmAddObjectDefConstraint(nugget3ID, avoidCaribou);
      //rmAddObjectDefConstraint(nugget3ID, avoidBerries);
	  rmAddObjectDefConstraint(nugget3ID, avoidFruits);
      rmAddObjectDefConstraint(nugget3ID, nuggetAvoidNugget);
      rmAddObjectDefConstraint(nugget3ID, edgeConstraint);
      rmAddObjectDefConstraint(nugget3ID, avoidNatives);
      rmAddObjectDefConstraint(nugget3ID, avoidImpassableLand);
      rmAddObjectDefConstraint(nugget3ID, Westconstraint);
/*----------------------------------------------------------------------------------------------------------------*/    
	  rmSetObjectDefMinDistance(nugget3ID, 0.0);
      rmSetObjectDefMaxDistance(nugget3ID, rmXFractionToMeters(0.5));
      rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.0, 1.0, 3); 
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE NUGGET 4: ****************************************** //
/*================================================================================================================*/
      int nugget4ID=rmCreateObjectDef("Nugget Treasures 4");
    //rmAddObjectDefItem(nugget4ID, "nugget", 1, 0.0);
      rmAddObjectDefItem(nugget4ID, "nugget", 1, 6.0);
	  rmSetNuggetDifficulty(1, 3);
	  rmAddObjectDefToClass(nugget4ID, rmClassID("nuggets"));
/*----------------------------------------------------------------------------------------------------------------*/	  
      rmAddObjectDefConstraint(nugget4ID, avoidGold);
	  rmAddObjectDefConstraint(nugget4ID, avoidMoose);
	  rmAddObjectDefConstraint(nugget4ID, forestConstraint);
      rmAddObjectDefConstraint(nugget4ID, avoidMuskOx);
      rmAddObjectDefConstraint(nugget4ID, avoidNugget);
      rmAddObjectDefConstraint(nugget4ID, avoidCaribou);
      //rmAddObjectDefConstraint(nugget4ID, avoidBerries);
	  rmAddObjectDefConstraint(nugget4ID, avoidFruits);
      rmAddObjectDefConstraint(nugget4ID, nuggetAvoidNugget);
      rmAddObjectDefConstraint(nugget4ID, edgeConstraint);
      rmAddObjectDefConstraint(nugget4ID, avoidNatives);
      rmAddObjectDefConstraint(nugget4ID, avoidImpassableLand);
      rmAddObjectDefConstraint(nugget4ID, Eastconstraint);
/*----------------------------------------------------------------------------------------------------------------*/	
	  rmSetObjectDefMinDistance(nugget4ID, 0.0);
      rmSetObjectDefMaxDistance(nugget4ID, rmXFractionToMeters(0.5));
      rmPlaceObjectDefAtLoc(nugget4ID, 0, 1.0, 0.0, 3); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME EXTRA HERDS 1: ************************************* //  
/*================================================================================================================*/ 
	  int mooseHerdID=rmCreateObjectDef("moose herd 1");
	  rmAddObjectDefItem(mooseHerdID, "moose", rmRandInt(2,3), 6.0);
	  rmSetObjectDefCreateHerd(mooseHerdID, true);
	  rmSetObjectDefMinDistance(mooseHerdID, 0.0);
	  //rmSetObjectDefMaxDistance(mooseHerdID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(mooseHerdID, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmAddObjectDefConstraint(mooseHerdID, shortAvoidCoin);
	  //rmAddObjectDefConstraint(mooseHerdID, edgeConstraint);
	  //rmAddObjectDefConstraint(mooseHerdID, avoidAll);
	  //rmAddObjectDefConstraint(mooseHerdID, shortPlayerConstraint);
	  //rmAddObjectDefConstraint(mooseHerdID, forestConstraint); // test
	  //rmAddObjectDefConstraint(mooseHerdID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(mooseHerdID, Northward);
	  rmAddObjectDefConstraint(mooseHerdID, avoidMoose);
	  //rmAddObjectDefConstraint(mooseHerdID, shortDeerConstraint);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.5, 0.5);
	  rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.58, 0.95);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.085, 0.68);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.95, 0.58);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.68, 0.085);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME EXTRA HERDS 2: ************************************* //  
/*================================================================================================================*/ 
	  int mooseHerd2ID=rmCreateObjectDef("moose herd 2");
	  rmAddObjectDefItem(mooseHerd2ID, "moose", rmRandInt(2,3), 6.0);
	  rmSetObjectDefCreateHerd(mooseHerd2ID, true);
	  rmSetObjectDefMinDistance(mooseHerd2ID, 0.0);
	  //rmSetObjectDefMaxDistance(mooseHerd2ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(mooseHerd2ID, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmAddObjectDefConstraint(mooseHerd2ID, shortAvoidCoin);
	  //rmAddObjectDefConstraint(mooseHerd2ID, edgeConstraint);
	  //rmAddObjectDefConstraint(mooseHerd2ID, avoidAll);
	  //rmAddObjectDefConstraint(mooseHerd2ID, forestConstraint); // test
	  //rmAddObjectDefConstraint(mooseHerd2ID, shortPlayerConstraint);
	  //rmAddObjectDefConstraint(mooseHerd2ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(mooseHerd2ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(mooseHerd2ID, Northward);
	  rmAddObjectDefConstraint(mooseHerd2ID, avoidMoose);
	  //rmAddObjectDefConstraint(mooseHerd2ID, shortDeerConstraint);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.5, 0.5); //test
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.58, 0.95);
	    rmPlaceObjectDefAtLoc(mooseHerd2ID, 0, 0.085, 0.68);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.95, 0.58);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.68, 0.085);	
/*================================================================================================================*/
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE SOME EXTRA HERDS 3: ************************************* //  
/*================================================================================================================*/ 
	  int mooseHerd3ID=rmCreateObjectDef("moose herd 3");
	  rmAddObjectDefItem(mooseHerd3ID, "moose", rmRandInt(2,3), 6.0);
	  rmSetObjectDefCreateHerd(mooseHerd3ID, true);
	  rmSetObjectDefMinDistance(mooseHerd3ID, 0.0);
	  //rmSetObjectDefMaxDistance(mooseHerd3ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(mooseHerd3ID, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmAddObjectDefConstraint(mooseHerd3ID, shortAvoidCoin);
	  //rmAddObjectDefConstraint(mooseHerd3ID, edgeConstraint);
	  //rmAddObjectDefConstraint(mooseHerd3ID, avoidAll);
	  //rmAddObjectDefConstraint(mooseHerd3ID, forestConstraint); // test
	  //rmAddObjectDefConstraint(mooseHerd3ID, shortPlayerConstraint);
	  //rmAddObjectDefConstraint(mooseHerd3ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(mooseHerd3ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(mooseHerd3ID, Northward);
	  rmAddObjectDefConstraint(mooseHerd3ID, avoidMoose);
	  //rmAddObjectDefConstraint(mooseHerd3ID, shortDeerConstraint);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.5, 0.5); // testing
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.58, 0.95);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.085, 0.68);
	  rmPlaceObjectDefAtLoc(mooseHerd3ID, 0, 0.95, 0.58);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.68, 0.085);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE SOME EXTRA HERDS 4: ************************************ //  
/*================================================================================================================*/ 
	  int mooseHerd4ID=rmCreateObjectDef("moose herd 4");
	  rmAddObjectDefItem(mooseHerd4ID, "moose", rmRandInt(2,3), 6.0);
	  rmSetObjectDefCreateHerd(mooseHerd4ID, true);
	  rmSetObjectDefMinDistance(mooseHerd4ID, 0.0);
	  //rmSetObjectDefMaxDistance(mooseHerd4ID, rmXFractionToMeters(0.5));
	  rmSetObjectDefMaxDistance(mooseHerd4ID, 0.0);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmAddObjectDefConstraint(mooseHerd4ID, shortAvoidCoin);
	  //rmAddObjectDefConstraint(mooseHerd4ID, edgeConstraint);
	  //rmAddObjectDefConstraint(mooseHerd4ID, avoidAll);
	  //rmAddObjectDefConstraint(mooseHerd4ID, forestConstraint);//test
	  //rmAddObjectDefConstraint(mooseHerd4ID, shortPlayerConstraint);
	  //rmAddObjectDefConstraint(mooseHerd4ID, avoidTradeRoute);
	  //rmAddObjectDefConstraint(mooseHerd4ID, avoidImpassableLand);
	  //rmAddObjectDefConstraint(mooseHerd4ID, Northward);
	  rmAddObjectDefConstraint(mooseHerd4ID, avoidMoose);
	  //rmAddObjectDefConstraint(mooseHerd4ID, shortDeerConstraint);
/*----------------------------------------------------------------------------------------------------------------*/	  
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.5, 0.5);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.58, 0.95);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.085, 0.68);
	  //rmPlaceObjectDefAtLoc(mooseHerdID, 0, 0.95, 0.58);
	  rmPlaceObjectDefAtLoc(mooseHerd4ID, 0, 0.68, 0.085);	  
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE CARIBOU 1: ****************************************** //
/*================================================================================================================*/
      int caribouID=rmCreateObjectDef("caribou herd 1");
      //rmAddObjectDefItem(caribouID, "caribou", 1, 0.0);
        rmAddObjectDefItem(caribouID, "caribou", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(caribouID, 20.0);
      rmSetObjectDefMaxDistance(caribouID, 30.0);
      rmAddObjectDefConstraint(caribouID, avoidGold);
	  rmAddObjectDefConstraint(caribouID, avoidMoose);
      rmAddObjectDefConstraint(caribouID, forestConstraint);
      rmAddObjectDefConstraint(caribouID, avoidMuskOx);
      rmAddObjectDefConstraint(caribouID, avoidNatives);
      rmAddObjectDefConstraint(caribouID, avoidCaribou);
      //rmAddObjectDefConstraint(caribouID, avoidBerries);
	  rmAddObjectDefConstraint(caribouID, avoidFruits);
      rmAddObjectDefConstraint(caribouID, caribouAvoidCaribou);
      rmAddObjectDefConstraint(caribouID, edgeConstraint);
      rmAddObjectDefConstraint(caribouID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(caribouID, true);
      rmPlaceObjectDefPerPlayer(caribouID, false);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE CARIBOU 2: ****************************************** //
/*================================================================================================================*/
      int caribou2ID=rmCreateObjectDef("caribou herd 2");
      //rmAddObjectDefItem(caribou2ID, "caribou", 1, 0.0);
      rmAddObjectDefItem(caribou2ID, "caribou", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(caribou2ID, 40.0);
      rmSetObjectDefMaxDistance(caribou2ID, 60.0);
      rmAddObjectDefConstraint(caribou2ID, avoidGold);
	  rmAddObjectDefConstraint(caribou2ID, avoidMoose);
      rmAddObjectDefConstraint(caribou2ID, forestConstraint);
      rmAddObjectDefConstraint(caribou2ID, avoidMuskOx);
      rmAddObjectDefConstraint(caribou2ID, avoidNatives);
      rmAddObjectDefConstraint(caribou2ID, avoidCaribou);
      //rmAddObjectDefConstraint(caribou2ID, avoidBerries);
	  rmAddObjectDefConstraint(caribou2ID, avoidFruits);
      rmAddObjectDefConstraint(caribou2ID, edgeConstraint);
      rmAddObjectDefConstraint(caribou2ID, caribouAvoidCaribou);
      rmAddObjectDefConstraint(caribou2ID, avoidImpassableLand);
      rmSetObjectDefCreateHerd(caribou2ID, true);
      rmPlaceObjectDefPerPlayer(caribou2ID, false);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE CARIBOU 3: ****************************************** //
/*================================================================================================================*/
      int caribou3ID=rmCreateObjectDef("caribou herd 3");
	  rmAddObjectDefItem(caribou3ID, "caribou", rmRandInt(3,5), 6);
	  rmSetObjectDefMinDistance(caribou3ID, 0.0);
	  rmSetObjectDefMaxDistance(caribou3ID, rmXFractionToMeters(0.3));
      rmAddObjectDefConstraint(caribou3ID, avoidAll);
	  rmAddObjectDefConstraint(caribou3ID, Westconstraint);
	  rmAddObjectDefConstraint(caribou3ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(caribou3ID, avoidGold);
	  rmAddObjectDefConstraint(caribou3ID, avoidMoose);
	  rmAddObjectDefConstraint(caribou3ID, playerConstraint);
	  rmAddObjectDefConstraint(caribou3ID, avoidMuskOx);
	  rmAddObjectDefConstraint(caribou3ID, avoidNatives);
	  rmAddObjectDefConstraint(caribou3ID, avoidCaribou);
	  rmAddObjectDefConstraint(caribou3ID, forestConstraint);
	  //rmAddObjectDefConstraint(caribou3ID, avoidBerries);
	  rmAddObjectDefConstraint(caribou3ID, avoidFruits);
	  rmAddObjectDefConstraint(caribou3ID, caribouAvoidCaribou);
	  rmAddObjectDefConstraint(caribou3ID, edgeConstraint);
	  rmSetObjectDefCreateHerd(caribou3ID, true);
      rmPlaceObjectDefAtLoc(caribou3ID, 0, 0.0, 1.0, 2);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE CARIBOU 4: ****************************************** //
/*================================================================================================================*/
      int caribou4ID=rmCreateObjectDef("caribou herd 4");
	  rmAddObjectDefItem(caribou4ID, "caribou", rmRandInt(3,5), 6);
	  rmSetObjectDefMinDistance(caribou4ID, 0.0);
	  rmSetObjectDefMaxDistance(caribou4ID, rmXFractionToMeters(0.3));
      rmAddObjectDefConstraint(caribou4ID, avoidCaribou);
	  rmAddObjectDefConstraint(caribou4ID, avoidMoose);
	  rmAddObjectDefConstraint(caribou4ID, avoidAll);
	  rmAddObjectDefConstraint(caribou4ID, Eastconstraint);
	  rmAddObjectDefConstraint(caribou4ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(caribou4ID, avoidGold);
	  rmAddObjectDefConstraint(caribou4ID, playerConstraint);
	  rmAddObjectDefConstraint(caribou4ID, avoidMuskOx);
	  rmAddObjectDefConstraint(caribou4ID, avoidNatives);
	  rmAddObjectDefConstraint(caribou4ID, forestConstraint);
	  //rmAddObjectDefConstraint(caribou4ID, avoidBerries);
	  rmAddObjectDefConstraint(caribou4ID, avoidFruits);
	  rmAddObjectDefConstraint(caribou4ID, caribouAvoidCaribou);
	  rmAddObjectDefConstraint(caribou4ID, edgeConstraint);
	  rmSetObjectDefCreateHerd(caribou4ID, true);
      rmPlaceObjectDefAtLoc(caribou4ID, 0, 1.0, 0.0, 2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE GOLD MINES 1: ****************************************** //
/*================================================================================================================*/
   int mediumGoldID=rmCreateObjectDef("medium gold 1");
   rmAddObjectDefItem(mediumGoldID, "minegold", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGoldID, 40.0);
   rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
   rmAddObjectDefConstraint(mediumGoldID, avoidGold);
   rmAddObjectDefConstraint(mediumGoldID, avoidMoose);
   rmAddObjectDefConstraint(mediumGoldID, avoidCaribou);
   rmAddObjectDefConstraint(mediumGoldID, forestConstraint);
   rmAddObjectDefConstraint(mediumGoldID, avoidNatives);
   rmAddObjectDefConstraint(mediumGoldID, avoidMuskOx);
   //rmAddObjectDefConstraint(mediumGoldID, avoidBerries);
   rmAddObjectDefConstraint(mediumGoldID, avoidFruits);
   rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGoldID, goldAvoidGold);
   rmAddObjectDefConstraint(mediumGoldID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumGoldID, avoidNugget);
   rmPlaceObjectDefPerPlayer(mediumGoldID, false);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE GOLD MINES 2: ****************************************** //
/*================================================================================================================*/
   int mediumGold2ID=rmCreateObjectDef("medium gold 2");
   rmAddObjectDefItem(mediumGold2ID, "minegold", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGold2ID, 20.0);
   rmSetObjectDefMaxDistance(mediumGold2ID, 30.0);
   rmAddObjectDefConstraint(mediumGold2ID, avoidGold);
   rmAddObjectDefConstraint(mediumGold2ID, avoidMoose);
   rmAddObjectDefConstraint(mediumGold2ID, avoidCaribou);
   rmAddObjectDefConstraint(mediumGold2ID, forestConstraint);
   rmAddObjectDefConstraint(mediumGold2ID, avoidNatives);
   rmAddObjectDefConstraint(mediumGold2ID, avoidMuskOx);
   //rmAddObjectDefConstraint(mediumGold2ID, avoidBerries);
   rmAddObjectDefConstraint(mediumGold2ID, avoidFruits);
   rmAddObjectDefConstraint(mediumGold2ID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGold2ID, goldAvoidGold);
   rmAddObjectDefConstraint(mediumGold2ID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumGold2ID, avoidNugget);
   rmPlaceObjectDefPerPlayer(mediumGold2ID, false); 
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE GOLD MINES 3: ****************************************** //
/*================================================================================================================*/
   int mediumGold3ID=rmCreateObjectDef("medium gold 3");
   rmAddObjectDefItem(mediumGold3ID, "minegold", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGold3ID, 0.0);
   rmSetObjectDefMaxDistance(mediumGold3ID, rmXFractionToMeters(0.5));
   //rmSetObjectDefMinDistance(mediumGold3ID, 20.0);
   //rmSetObjectDefMaxDistance(mediumGold3ID, 30.0);
   rmAddObjectDefConstraint(mediumGold3ID, avoidGold);
   rmAddObjectDefConstraint(mediumGold3ID, avoidMoose);
   rmAddObjectDefConstraint(mediumGold3ID, avoidCaribou);
   rmAddObjectDefConstraint(mediumGold3ID, forestConstraint);
   rmAddObjectDefConstraint(mediumGold3ID, avoidNatives);
   rmAddObjectDefConstraint(mediumGold3ID, avoidNugget);
   rmAddObjectDefConstraint(mediumGold3ID, avoidMuskOx);
   //rmAddObjectDefConstraint(mediumGold3ID, avoidBerries);
   rmAddObjectDefConstraint(mediumGold3ID, avoidFruits);
   rmAddObjectDefConstraint(mediumGold3ID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGold3ID, goldAvoidGold);
   rmAddObjectDefConstraint(mediumGold3ID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumGold3ID, Westconstraint);
   //rmPlaceObjectDefPerPlayer(mediumGold3ID, false);
   rmPlaceObjectDefAtLoc(mediumGold3ID, 0, 0.0, 1.0, 3);  
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE GOLD MINES 4: ****************************************** //
/*================================================================================================================*/
   int mediumGold4ID=rmCreateObjectDef("medium gold 4");
   rmAddObjectDefItem(mediumGold4ID, "minegold", 1, 0.0);
   rmSetObjectDefMinDistance(mediumGold4ID, 0.0);
   rmSetObjectDefMaxDistance(mediumGold4ID, rmXFractionToMeters(0.5));
   //rmSetObjectDefMinDistance(mediumGold4ID, 20.0);
   //rmSetObjectDefMaxDistance(mediumGold4ID, 30.0);
   rmAddObjectDefConstraint(mediumGold4ID, avoidGold);
   rmAddObjectDefConstraint(mediumGold4ID, avoidMoose);
   rmAddObjectDefConstraint(mediumGold4ID, avoidCaribou);
   rmAddObjectDefConstraint(mediumGoldID, forestConstraint);
   rmAddObjectDefConstraint(mediumGold4ID, avoidNugget);
   rmAddObjectDefConstraint(mediumGold4ID, avoidMuskOx);
   rmAddObjectDefConstraint(mediumGold4ID, avoidNatives);
   //rmAddObjectDefConstraint(mediumGold4ID, avoidBerries);
   rmAddObjectDefConstraint(mediumGold4ID, avoidFruits);
   rmAddObjectDefConstraint(mediumGold4ID, edgeConstraint);
   rmAddObjectDefConstraint(mediumGold4ID, goldAvoidGold);
   rmAddObjectDefConstraint(mediumGold4ID, avoidImpassableLand);
   rmAddObjectDefConstraint(mediumGold4ID, Eastconstraint);
   //rmPlaceObjectDefPerPlayer(mediumGold4ID, false);
   rmPlaceObjectDefAtLoc(mediumGold4ID, 0, 1.0, 0.0, 3); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE BERRY BUSH 1: ***************************************** //
/*================================================================================================================*/
      int berriesID=rmCreateObjectDef("The Berries 1");
      //rmAddObjectDefItem(berriesID, "berrybush", 1, 0.0);
      rmAddObjectDefItem(berriesID, "berrybush", 3, 6.0);
      rmSetObjectDefMinDistance(berriesID, 0.0);
      rmSetObjectDefMaxDistance(berriesID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(berriesID, avoidGold);
	  rmAddObjectDefConstraint(berriesID, avoidMoose);
      rmAddObjectDefConstraint(berriesID, forestConstraint);
      rmAddObjectDefConstraint(berriesID, avoidCaribou);
      rmAddObjectDefConstraint(berriesID, avoidMuskOx);
      rmAddObjectDefConstraint(berriesID, avoidNugget);
      //rmAddObjectDefConstraint(berriesID, avoidBerries);
	  rmAddObjectDefConstraint(berriesID, avoidFruits);
      //rmAddObjectDefConstraint(berriesID, berriesAvoidBerries);
	  rmAddObjectDefConstraint(berriesID, fruitsAvoidFruits);
      rmAddObjectDefConstraint(berriesID, edgeConstraint);
      rmAddObjectDefConstraint(berriesID, avoidNatives);
      rmAddObjectDefConstraint(berriesID, avoidImpassableLand);
      rmAddObjectDefConstraint(berriesID, Eastconstraint);
      rmPlaceObjectDefAtLoc(berriesID, 0, 1.0, 0.0, 4); 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE BERRY BUSH 2: ***************************************** //
/*================================================================================================================*/
      int berries2ID=rmCreateObjectDef("The Berries 2");
      //rmAddObjectDefItem(berries2ID, "berrybush", 1, 0.0);
      rmAddObjectDefItem(berries2ID, "berrybush", 3, 6.0);
      rmSetObjectDefMinDistance(berries2ID, 0.0);
      rmSetObjectDefMaxDistance(berries2ID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(berries2ID, avoidGold);
	  rmAddObjectDefConstraint(berries2ID, avoidMoose);
      rmAddObjectDefConstraint(berries2ID, forestConstraint);
      rmAddObjectDefConstraint(berries2ID, avoidCaribou);
      rmAddObjectDefConstraint(berries2ID, avoidMuskOx);
      rmAddObjectDefConstraint(berries2ID, avoidNugget);
      //rmAddObjectDefConstraint(berries2ID, avoidBerries);
	  rmAddObjectDefConstraint(berries2ID, avoidFruits);
      //rmAddObjectDefConstraint(berries2ID, berriesAvoidBerries);
	  rmAddObjectDefConstraint(berries2ID, fruitsAvoidFruits);
      rmAddObjectDefConstraint(berries2ID, edgeConstraint);
      rmAddObjectDefConstraint(berries2ID, avoidNatives);
      rmAddObjectDefConstraint(berries2ID, avoidImpassableLand);
      rmAddObjectDefConstraint(berries2ID, Westconstraint);
      rmPlaceObjectDefAtLoc(berries2ID, 0, 0.0, 1.0, 4); 
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE BERRY BUSH 3: ***************************************** //
/*================================================================================================================*/
      int berries3ID=rmCreateObjectDef("The Berries 3");
      //rmAddObjectDefItem(berries3ID, "berrybush", 1, 0.0);
      rmAddObjectDefItem(berries3ID, "berrybush", 3, 6.0);
      rmSetObjectDefMinDistance(berries3ID, 20.0);
      rmSetObjectDefMaxDistance(berries3ID, 30.0);
      rmAddObjectDefConstraint(berries3ID, avoidGold);
	  rmAddObjectDefConstraint(berries3ID, avoidMoose);
      rmAddObjectDefConstraint(berries3ID, forestConstraint);
      rmAddObjectDefConstraint(berries3ID, avoidCaribou);
      rmAddObjectDefConstraint(berries3ID, avoidMuskOx);
      rmAddObjectDefConstraint(berries3ID, avoidNugget);
      //rmAddObjectDefConstraint(berries3ID, avoidBerries);
	  rmAddObjectDefConstraint(berries3ID, avoidFruits);
      //rmAddObjectDefConstraint(berries3ID, berriesAvoidBerries);
	  rmAddObjectDefConstraint(berries3ID, fruitsAvoidFruits);
      rmAddObjectDefConstraint(berries3ID, edgeConstraint);
      rmAddObjectDefConstraint(berries3ID, avoidNatives);
      rmAddObjectDefConstraint(berries3ID, avoidImpassableLand);
      rmPlaceObjectDefPerPlayer(berries3ID, false);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE BERRY BUSH 4: ***************************************** //
/*================================================================================================================*/
      int berries4ID=rmCreateObjectDef("The Berries 4");
      //rmAddObjectDefItem(berries4ID, "berrybush", 1, 0.0);
      rmAddObjectDefItem(berries4ID, "berrybush", 3, 6.0);
      rmSetObjectDefMinDistance(berries4ID, 40.0);
      rmSetObjectDefMaxDistance(berries4ID, 60.0);
      rmAddObjectDefConstraint(berries4ID, avoidGold);
	  rmAddObjectDefConstraint(berries4ID, avoidMoose);
      rmAddObjectDefConstraint(berries4ID, forestConstraint);
      rmAddObjectDefConstraint(berries4ID, avoidCaribou);
      rmAddObjectDefConstraint(berries4ID, avoidMuskOx);
      rmAddObjectDefConstraint(berries4ID, avoidNugget);
      //rmAddObjectDefConstraint(berries4ID, avoidBerries);
	  rmAddObjectDefConstraint(berries4ID, avoidFruits);
      //rmAddObjectDefConstraint(berries4ID, berriesAvoidBerries);
	  rmAddObjectDefConstraint(berries4ID, fruitsAvoidFruits);
      rmAddObjectDefConstraint(berries4ID, edgeConstraint);
      rmAddObjectDefConstraint(berries4ID, avoidNatives);
      rmAddObjectDefConstraint(berries4ID, avoidImpassableLand);
      rmPlaceObjectDefPerPlayer(berries4ID, false);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE FISHSALMON: **************************************** //
/*================================================================================================================*/
      int fishID=rmCreateObjectDef("fish");
      rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 25);
/*================================================================================================================*/
// ******************************** DEFINE  AND PLACE THE FAST COIN -- WHALES *********************************** //
/*================================================================================================================*/	 
	  int whaleID=rmCreateObjectDef("whale");
      rmAddObjectDefItem(whaleID, "beluga", 1, 9.0);
      rmSetObjectDefMinDistance(whaleID, 0.0);
      rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
      rmAddObjectDefConstraint(whaleID, whaleLand);
      rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 2);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE COLONY SHIP: *************************************** //
/*================================================================================================================*/
        int colonyShipID = 0;
/*----------------------------------------------------------------------------------------------------------------*/	  
        for(i=1; <cNumberPlayers)
/*----------------------------------------------------------------------------------------------------------------*/	  
   {
		colonyShipID=rmCreateObjectDef("colony ship "+i);
	    
  		rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 5.0);
		rmAddObjectDefConstraint(colonyShipID, shipVsShip);
		rmAddObjectDefConstraint(colonyShipID, fishLand);
		rmSetObjectDefMinDistance(colonyShipID, 0.0);
		rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.35));

		//rmPlaceObjectDefAtLoc(colonyShipID, i, 1.0, 1.0, 1);
		  rmPlaceObjectDefAtLoc(colonyShipID, i, 0.5, 0.5, 1);
   } 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE RANDOM TREES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
        int TreeID= rmCreateObjectDef("tree"); 
		//rmAddObjectDefItem(TreeID, "TreeSaguenay", 1, 0.0);
		rmAddObjectDefItem(TreeID, "TreeGreatLakesSnow", rmRandInt(1,3), 4.0);
		rmSetObjectDefMinDistance(TreeID, 0.0);
        rmSetObjectDefMaxDistance(TreeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(TreeID, rmCreateTypeDistanceConstraint("TreeGreatLakesSnow", "all", 4.0));
		rmAddObjectDefConstraint(TreeID, avoidImpassableLand);
  		rmAddObjectDefConstraint(TreeID, avoidNugget);
  		//rmAddObjectDefConstraint(TreeID, avoidBerries);
		rmAddObjectDefConstraint(TreeID, avoidFruits);
		rmAddObjectDefConstraint(TreeID, avoidMuskOx);
		rmAddObjectDefConstraint(TreeID, playerConstraint);
		rmAddObjectDefConstraint(TreeID, avoidGold);
		rmAddObjectDefConstraint(TreeID, avoidCaribou);
		rmAddObjectDefConstraint(TreeID, avoidNatives);
  		rmAddObjectDefConstraint(TreeID, avoidAll);
		rmAddObjectDefConstraint(TreeID, avoidMoose);
		rmAddObjectDefConstraint(TreeID, forestConstraint);
		rmAddObjectDefConstraint(TreeID, edgeConstraint);
		rmPlaceObjectDefAtLoc(TreeID, 0, 0.5, 0.5, 75);   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}  
/*----------------------------------------------------------------------------------------------------------------*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*----------------------------------------------------------------------------------------------------------------*/